// Code generated by protoc-gen-defaults. DO NOT EDIT.

package bookpb

import "context"

import "go.uber.org/fx"

import "github.com/golang/protobuf/ptypes/empty"

import "go.appointy.com/pehredaar/src/rights"

import "go.appointy.com/pehredaar/src/pehredaar"

import "go.appointy.com/pehredaar/src/user"

var BooksResourcePaths = [...]string{}

type RightsBooksServer struct {
	BooksServer
	rightsCli rights.RightValidatorsClient
	user      user.UserIDer
}

func init() {
	pehredaar.Options = append(pehredaar.Options, fx.Provide(NewRightsBooksClient))
}

type RightsBooksClientResult struct {
	fx.Out
	BooksClient BooksClient `name:"r"`
}

func NewRightsBooksClient(c rights.RightValidatorsClient, s BooksServer, u user.UserIDer) RightsBooksClientResult {
	return RightsBooksClientResult{BooksClient: NewLocalBooksClient(NewRightsBooksServer(c, s, u))}
}
func NewRightsBooksServer(c rights.RightValidatorsClient, s BooksServer, u user.UserIDer) BooksServer {
	return &RightsBooksServer{
		s,
		c,
		u,
	}
}

func (s *RightsBooksServer) CreateBook(ctx context.Context, rightsvar *CreateBookRequest) (*Book, error) {

	return s.BooksServer.CreateBook(ctx, rightsvar)
}

func (s *RightsBooksServer) GetBook(ctx context.Context, rightsvar *GetBookRequest) (*Book, error) {

	return s.BooksServer.GetBook(ctx, rightsvar)
}

func (s *RightsBooksServer) UpdateBook(ctx context.Context, rightsvar *UpdateBookRequest) (*empty.Empty, error) {

	return s.BooksServer.UpdateBook(ctx, rightsvar)
}

func (s *RightsBooksServer) DeleteBook(ctx context.Context, rightsvar *DeleteBookRequest) (*empty.Empty, error) {

	return s.BooksServer.DeleteBook(ctx, rightsvar)
}

func (s *RightsBooksServer) ListBook(ctx context.Context, rightsvar *ListBookRequest) (*ListBookResponse, error) {

	return s.BooksServer.ListBook(ctx, rightsvar)
}
